import { Injectable } from '@nestjs/common';
import { CreateExploitDto, SearchExploitsDto } from './dto';
import { ExploitDAO } from './exploit.dao';
import { Exploit } from '@prisma/client';

@Injectable()
export class ExploitService {
  constructor(private exploitDAO: ExploitDAO) {}

  async createExploit(createExploitDto: CreateExploitDto): Promise<Exploit> {
    return this.exploitDAO.create(createExploitDto);
  }

  async getExploit(exploitId: string): Promise<Exploit> {
    return this.exploitDAO.get(exploitId);
  }

  async getUserExploit(userId: string, page: number): Promise<Exploit[]> {
    return this.exploitDAO.getByUser(userId, page);
  }

  async searchExploitByName(
    searchExploitsDto: SearchExploitsDto
  ): Promise<Exploit[]> {
    return this.exploitDAO.searchByName(searchExploitsDto);
  }

  async verifyExploit(exploitId: string) {
    await this.exploitDAO.verify(exploitId);
  }
}
